package com.wgy.actionscript
{
	import flash.events.MouseEvent;
	
	import flash.events.Event;
	
	import mx.controls.Alert;
	import mx.controls.CheckBox;
	import mx.controls.Tree;
	import mx.controls.treeClasses.TreeItemRenderer;
	import mx.controls.treeClasses.TreeListData;
	
	/**
	 * 支持CheckBox的TreeItemRenderer
	 * @author wgy
	 */    
	public class TreeCheckBoxRenderer extends TreeItemRenderer
	{
		public function TreeCheckBoxRenderer()
		{
			super();
		}
		
		/**
		 * 表示CheckBox控件从data中所取数据的字段
		 */        
		
		protected var checkBox:CheckBox;
		
		/**
		 * 构建CheckBox
		 */        
		override protected function createChildren():void
		{
			super.createChildren();
			checkBox = new CheckBox();
			addChild( checkBox );
			checkBox.addEventListener(Event.CHANGE, changeHandler);
		}
		
		/**
		 * 点击checkbox时,更新dataProvider
		 * @param event
		 */        
		protected function changeHandler( event:Event ):void
		{
			if(null==data){
			   return ;
			}
			if( data.@state== "checked")
			{
				data.@state= "unchecked";
				return ;
				/**
				 * 如果有需要，在这里处理选中父，全选子节点的方法(这个方式暂时去掉，如果有需要去掉注释即可)。
				 * */
//				for (var i:int=0;i<data.children().length();i++)
//				{
//					data.children()[i].@selected=checkBox.selected.toString();;
//					
//				}     	
			}
			data.@state= "checked";
	
		} 
		
		
		/**
		 * 初始化控件时, 给checkbox赋值
		 */        
		override protected function commitProperties():void
		{
			super.commitProperties();
			if(null==data){
			    return;
			}
			if(data.@state!="" )
			{
				if(data.@state=="checked"){
					checkBox.selected=true;
				}else{
					checkBox.selected=false;
				}
			}
			else
			{
				checkBox.selected = false;
			}
			
		}
		
		/**
		 * 重置itemRenderer的宽度
		 */        
		override protected function measure():void
		{
			super.measure();
			measuredWidth += checkBox.getExplicitOrMeasuredWidth();
		}
		
		/**
		 * 重新排列位置, 将label后移
		 * @param unscaledWidth
		 * @param unscaledHeight
		 */        
		override protected function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
		{
			super.updateDisplayList(unscaledWidth, unscaledHeight);
			var startx:Number = data ? TreeListData( listData ).indent : 0;
			
			if (disclosureIcon)
			{
				disclosureIcon.x = startx;
				
				startx = disclosureIcon.x + disclosureIcon.width;
				
				disclosureIcon.setActualSize(disclosureIcon.width,
					disclosureIcon.height);
				
				disclosureIcon.visible = data ?
					TreeListData( listData ).hasChildren :
					false;
			}
			
			if (icon)
			{
				icon.x = startx;
				startx = icon.x + icon.measuredWidth;
				icon.setActualSize(icon.measuredWidth, icon.measuredHeight);
			}
			
			checkBox.move(startx, ( unscaledHeight - checkBox.height ) / 2 );
			
			label.x = startx + checkBox.getExplicitOrMeasuredWidth();
		}
	}
}