package com.wgy.common.util;

import java.io.Serializable;
import java.lang.reflect.ParameterizedType;
import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.List;

import com.wgy.common.service.CommonVo;


public abstract class PageInfo< T extends CommonVo> implements Serializable{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -1715428528373631890L;

	private int pageIndex=1;
	
	private int perPageItems=10;
	
	private int pageCount=0;
	
	private int itemsCount=0;
	
	private boolean isFirst = true ;
	
	private boolean isLast = false;
	
	private List<T> result;	
	
	public abstract void convertVo(T vo);

	public PageInfo() {
		super();
		this.result=new ArrayList<T>();
	}
	
	@SuppressWarnings("unchecked")
	public Class<Object> findGenericType(int index) {
		Type genType = getClass().getGenericSuperclass();
		if (!(genType instanceof ParameterizedType)) {
			return Object.class;
		}
		Type[] params = ((ParameterizedType) genType).getActualTypeArguments();
		if (index >= params.length || index < 0) {
			throw new RuntimeException("Index outof bounds");
		}
		if (!(params[index] instanceof Class)) {
			return Object.class;
		}
		return (Class<Object>) params[index];
	}
		


	public int getPageIndex() {
		return pageIndex;
	}

	public void setPageIndex(int pageIndex) {
		this.pageIndex = pageIndex;
	}

	public int getPerPageItems() {
		return perPageItems;
	}

	public void setPerPageItems(int perPageItems) {
		this.perPageItems = perPageItems;
	}

	public int getPageCount() {
		return pageCount;
	}

	public void setPageCount(int pageCount) {
		this.pageCount = pageCount;
	}

	public int getItemsCount() {
		return itemsCount;
	}

	public void setItemsCount(int itemsCount) {
		this.itemsCount = itemsCount;
	}

	public boolean isFirst() {
		return isFirst;
	}

	public void setFirst(boolean isFirst) {
		this.isFirst = isFirst;
	}

	public boolean isLast() {
		return isLast;
	}

	public void setLast(boolean isLast) {
		this.isLast = isLast;
	}

	public List<T> getResult() {
		return result;
	}

	public void setResult(List<T> result) {
		this.result = result;
	}

}
