package com.wgy.common.util;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataAccessException;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.orm.hibernate3.HibernateTemplate;
import org.springframework.stereotype.Service;

@Service
public class BaseDao<T> {
	@Autowired
	JdbcTemplate jdbcTemplate;
	@Autowired
	HibernateTemplate hibernateTemplate;
	@Autowired
	UtilDaoTemplate utilDaoTemplate;
	
	/**
	 * Save An Object
	 * @param obj
	 * @return
	 */
	public String save(T obj){
		try {
			this.hibernateTemplate.save(obj);
			return "success";
		} catch (DataAccessException e) {
			e.printStackTrace();
			return "fail";
		}
		
	}
	
	/**
	 * Update An Object
	 */
	public String update(T obj){
		try {
			this.hibernateTemplate.saveOrUpdate(obj);
			return "success";
		} catch (DataAccessException e) {
			e.printStackTrace();
			return "fail";
		}
	}
	
	/**
	 * save  All Object
	 * @param obj
	 * @return
	 */
	public String saveAllEntity(List<T> obj){
		try {
			this.hibernateTemplate.saveOrUpdateAll(obj);
			return "success";
		} catch (DataAccessException e) {
			e.printStackTrace();
			return "fail";
		}
	}
	
	public String deleEntity(String sql){
		try {
			this.jdbcTemplate.execute(sql);
			return "success";
		} catch (DataAccessException e) {
			e.printStackTrace();
			return "fail";
		}
		
	}
	
	
}
