package com.wgy.common.util;

import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.jdbc.core.simple.ParameterizedBeanPropertyRowMapper;
import org.springframework.orm.hibernate3.HibernateTemplate;
import org.springframework.stereotype.Service;

import com.wgy.common.service.CommonVo;
import com.wgy.common.service.IDao;

@Service
public class UtilDaoTemplate implements IDao {
	@Autowired
	JdbcTemplate jdbcTemplate;
	@Autowired
	HibernateTemplate hibernateTemplate;
	@SuppressWarnings({ "unchecked", "rawtypes" })
	public <T> T queryForListWithPage(int pageIndex, int perPageItems,
			String sql, Object[] params, Class<? extends PageInfo> clazz)
			throws BizException {
		int p = sql.toLowerCase().indexOf("order by");
		if (p <= 1) {
			throw new BizException("分页查询时必须指定排序字段", "编码错误");
		}
		PageInfo<CommonVo> page;
		try {
			page = clazz.newInstance();
		} catch (InstantiationException e) {
			throw new BizException("构造分页查询时出现错误", "编码错误", e);
		} catch (IllegalAccessException e) {
			throw new BizException("构造分页查询时出现错误", "编码错误", e);
		}
		page.setPerPageItems(perPageItems); // 每页XX条
		int count = jdbcTemplate.queryForInt("select count(*) c from (" + sql
				+ ")", params);// 共xx条
		page.setItemsCount(count);
		int pageCount = (count % page.getPerPageItems() == 0) ? (count / page
				.getPerPageItems()) : (count / page.getPerPageItems() + 1);
		page.setPageCount(pageCount); // 共xx页
		if (pageIndex > pageCount) {
			pageIndex = pageCount;
		}
		page.setPageIndex(pageIndex); // 当前第XX页
		page.setFirst(pageIndex <= 1);
		page.setLast(pageCount <= pageIndex);

		int x = (pageIndex - 1) * perPageItems;
		int y = pageIndex * perPageItems;
		String pageSql = "select  *   from  "
				+ "(select  ttmp.*,rownum num from  " + "( " + sql
				+ " ) ttmp   " + "where  rownum <= " + y + ")  "
				+ "where  num > " + x;
		Class c = page.findGenericType(0);
		RowMapper mf = ParameterizedBeanPropertyRowMapper.newInstance(c);
		List<CommonVo> list = jdbcTemplate.query(pageSql, mf, params);
		for (CommonVo vo : list) {
			page.convertVo(vo);
		}
		page.setResult(list);
		return (T) page;
	}

	public PageInfoListMap queryForListWithPage(int pageIndex,
			int perPageItems, String sql, Object[] params) throws BizException {
		int p = sql.toLowerCase().indexOf("order by");
		if (p <= 1) {
			throw new BizException("分页查询时必须指定排序字段", "编码错误");
		}
		PageInfoListMap page = new PageInfoListMap();
		page.setPerPageItems(perPageItems); // 每页XX条
		int count = jdbcTemplate.queryForInt("select count(*) c from (" + sql
				+ ")", params);// 共xx条
		page.setItemsCount(count);
		int pageCount = (count % page.getPerPageItems() == 0) ? (count / page
				.getPerPageItems()) : (count / page.getPerPageItems() + 1);
		page.setPageCount(pageCount); // 共xx页
		if (pageIndex > pageCount) {
			pageIndex = pageCount;
		}
		page.setPageIndex(pageIndex); // 当前第XX页
		page.setFirst(pageIndex <= 1);
		page.setLast(pageCount <= pageIndex);
		int x = (pageIndex - 1) * perPageItems;
		int y = pageIndex * perPageItems;
		String pageSql = "select  *   from  "
				+ "(select  ttmp.*,rownum num from  " + "( " + sql
				+ " ) ttmp   " + "where  rownum <= " + y + ")  "
				+ "where  num > " + x;
		List<Map<String, Object>> list = jdbcTemplate.queryForList(pageSql,
				params);
		page.setResult(list);
		return page;
	}
}
