package com.wgy.system.service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.orm.hibernate3.HibernateTemplate;
import org.springframework.stereotype.Service;
import com.wgy.common.model.Smenu;
import com.wgy.common.util.BaseDao;
import com.wgy.common.util.BizException;
import com.wgy.common.util.UtilDaoTemplate;
import com.wgy.system.vo.MenuPageList;

@Service
public class MenuServiceImpl extends BaseDao<Smenu> implements IMenuService  {
	@Autowired
	JdbcTemplate jdbcTemplate;
	@Autowired
	HibernateTemplate hibernateTemplate;
	@Autowired
	UtilDaoTemplate utilDaoTemplate;
	/**
	 * 获取菜单的XML结构的字符串
	 */
	
	public String querySysMenuXmlString(String userId, boolean bool) {
		Document document = DocumentHelper.createDocument();
		Element root = document.addElement("root"); 
		String sql = firstMenu(userId,bool);
		List<Map<String,Object>> l=jdbcTemplate.queryForList(sql);
		
		for (Map<String, Object> map : l) {
			Element menuitem = root.addElement("menuitem");
			menuitem.addAttribute("label", checkNullValue(map.get("menuname")));
			menuitem.addAttribute("myurl", checkNullValue(map.get("menuurl")));
			menuitem.addAttribute("menuId", checkNullValue(map.get("ID")));
			procElement(menuitem,Integer.parseInt(checkNullValue(map.get("ID"))),userId,bool);
		}
		
		return document.asXML();
	}
	
	/**
	 * 获取一个菜单对应的所有子菜单
	 * @param menuitem
	 * @param pid
	 * @param userId
	 * @param bool
	 */
	private void procElement(Element menuitem, int pid,String userId,boolean bool) {
		
		String sql = secondMenu(userId,bool);
		List<Map<String,Object>> l=jdbcTemplate.queryForList(sql,new Object[]{pid});
		for (Map<String, Object> map : l) {
			Element submenu = menuitem.addElement("submenu");
			submenu.addAttribute("label", checkNullValue(map.get("menuname")));
			submenu.addAttribute("myurl", checkNullValue(map.get("menuurl")));
			submenu.addAttribute("menuId", checkNullValue(map.get("id")));
			procElement(submenu,Integer.parseInt(checkNullValue(map.get("id"))),userId,bool);
		}
		
	}
	private String firstMenu(String userId,boolean bool){
		StringBuffer bf = new StringBuffer();
		if(bool){
			
			bf.append(" select * from smenu menu_info where menu_info.parentid=0 ");
			bf.append(" and menu_info.id  in (select t.menuid from srolemenu t where t.roleid in ");
			bf.append(" (select infor.roleid from sroleadmin infor where infor.adminid ='"+userId+"')) ");
			bf.append(" order by menusort ");
		}
		else{
			bf.append(" select * from smenu menu_info where menu_info.parentid=0 ");
			bf.append(" order by menusort ");
		}
		return bf.toString();
	}
	
	private String secondMenu(String userId,boolean bool){
		StringBuffer bf = new StringBuffer();
		if(bool){
			bf.append(" select * from smenu menu_info where menu_info.parentid=? ");
			bf.append(" and menu_info.id  in (select t.menuid from srolemenu t where t.roleid in ");
			bf.append(" (select infor.roleid from sroleadmin infor where infor.adminid ='"+userId+"')) ");
			bf.append(" order by menusort ");
		}else{
			
			bf.append(" select * from smenu menu_info where menu_info.parentid=? ");
			
			bf.append(" order by menusort ");
		}
		return bf.toString();
		
	}
	
	/**
	 * 对NULL值做处理
	 * @param obj
	 * @return
	 */
	private String checkNullValue(Object obj){
		String str =" ";
		if(null==obj || "".equals(obj.toString().trim())){
			return str;
		}
		return obj.toString();
		
	}

	public MenuPageList queryMenuForPage(int begin, int perPage, String menuName) {
		StringBuffer bf = new StringBuffer();
		bf.append("  select t1.id,t1.menuname,t1.parentid, case  t1.parentid when 0 then '无' else  t1.menuname  end parentname,  ");
		bf.append("  t1.menusort,t1.menuurl,t1.menudesc from smenu t1 LEFT JOIN smenu t2 ON t1.id = t2.parentid ");
		List<String> params = new ArrayList<String>();
		if (menuName != null && !menuName.trim().equals("")) {
			params.add("%" + menuName.trim() + "%");
			bf.append(" and t1.menuname like ? ");
		}
		bf.append(" order by t1.id asc ");
		try {
			return utilDaoTemplate.queryForListWithPage(begin, perPage, bf.toString(), params.toArray(), MenuPageList.class);
		} catch (BizException e) {
			
			e.printStackTrace();
			return null;
		}
	}

	public List<Smenu> queryMenu(String menuName) {
		return null;
	}

	public String saveMenu(Smenu menuInfo) {
		return this.save(menuInfo);
	}

	public String saveMenuInfo(Smenu menuInfo) {
		return this.update(menuInfo);
	}

	public String deleteMenuById(int id) {
		String sql = " delete from smenu s where s.id='"+id+"' ";
		return this.deleEntity(sql);
	}
}
